import ARKit

/**
 The Plugin protocol. If you want to write a new plugin you must use this protocol.
 */
protocol Plugin {
    
    var pluginImage : UIImage? { get }
    var pluginIdentifier : String { get }
    var needsBluetoothARPen: Bool { get }
    var pluginInstructionsImage: UIImage? { get }
    var pluginDisabledImage: UIImage? { get } 
    
    var pluginManager: PluginManager? { get set }
    
    func activatePlugin()
    func deactivatePlugin()
    
}
